#include <fxcg/display.h>
#include <fxcg/keyboard.h>
#include <fxcg/file.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

char *conv_g3a;
#define SIZE 65536

int load(void)
{
    int fd = Bfile_OpenFile_OS(u"\\\\fls0\\Conv.g3a", BFILE_READ, 0);
    if(fd < 0) return -1;

    int rc = Bfile_ReadFile_OS(fd, conv_g3a, SIZE, -1);
    Bfile_CloseFile_OS(fd);
    return rc;
}

int save(int size)
{
    int fd = Bfile_OpenFile_OS(u"\\\\fls0\\Conv.g3a", BFILE_WRITE, 0);
    if(fd < 0) return -1;

    int rc = Bfile_WriteFile_OS(fd, conv_g3a, size);
    Bfile_CloseFile_OS(fd);
    return rc;
}

int main(void)
{
    conv_g3a = malloc(SIZE);
    if(!conv_g3a) return 1;

    int size = load();
    if(size < 0) return 1;

    char str[128];

    Bdisp_AllClr_VRAM();
    sprintf(str+2, "Loaded %d bytes", size);
    PrintXY(1, 1, str, 0, 0);
    Bdisp_PutDisp_DD();

    for(int i = 1; i <= 100; i++) {
        int rc = save(size);
        if(rc < 0) return 1;

        Bdisp_AllClr_VRAM();
        sprintf(str+2, "[%d] Saved %d bytes", i, rc);
        PrintXY(1, 1, str, 0, 0);
        Bdisp_PutDisp_DD();
    }

    return 1;
}
